/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: Analytics.java,v c90f4569fa41 2010/07/04 02:23:58 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.mobile.android.util;

import javax.annotation.Nonnull;
import java.io.UnsupportedEncodingException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLEncoder;
import org.openide.util.NbBundle;
import it.tidalwave.bluebill.mobile.android.about.AboutActivity;
import android.os.Build;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public final class Analytics
  {
    public static URL createURL (final @Nonnull String string)
      throws MalformedURLException
      {
        try 
          {
            final StringBuilder buffer = new StringBuilder(string);
            buffer.append(string.contains("?") ? "&" : "?");
            buffer.append("blueBillVersion=").append(encode(NbBundle.getMessage(AboutActivity.class, "title")));
            buffer.append("&osVersion=").append(encode(System.getProperty("os.version")));
            buffer.append("&javaVersion=").append(encode(System.getProperty("java.version")));
            buffer.append("&userLanguage=").append(encode(System.getProperty("user.language")));
            buffer.append("&userRegion=").append(encode(System.getProperty("user.region")));
            buffer.append("&board=").append(encode(Build.BOARD));
            buffer.append("&brand=").append(encode(Build.BRAND));
            buffer.append("&device=").append(encode(Build.DEVICE));
            buffer.append("&model=").append(encode(Build.MODEL));
            buffer.append("&product=").append(encode(Build.PRODUCT));
            buffer.append("&versionIncremental=").append(encode(Build.VERSION.INCREMENTAL));
            buffer.append("&versionRelease=").append(encode(Build.VERSION.RELEASE));
            buffer.append("&versionSDK=").append(encode(Build.VERSION.SDK));

            return new URL(buffer.toString());
          }
        catch (UnsupportedEncodingException e)
          {
            throw new MalformedURLException(e.toString());
         }
      }

    @Nonnull
    private static String encode (final @Nonnull String string)
      throws UnsupportedEncodingException
      {
        return (string == null) ? "" : URLEncoder.encode(string, "UTF-8");
      }
  }
